routes/web.php
<?php

Route::view('example','example.index');
Route::view('example/create','example.create');

// ROUTE WEB-PROFILE
Route::view('/','welcome');
Route::resource('attention','AttentionController');
Route::prefix('admin')->middleware('auth')->group(function(){
    Route::view('/','pages.other.dashboard')->name('admin');
    Route::resource('setting','SettingController');
    Route::resource('major','MajorController');
    Route::resource('school_year', 'SchoolYearController');
    Route::resource('subject','SubjectController');
    Route::resource('bill', 'BillController');
    Route::resource('bill_filter', 'BillFilterController');
    Route::resource('classgroup','ClassGroupController');
    Route::resource('video','VideoController');
    Route::resource('teacher', 'TeacherController');
    Route::resource('eskul', 'EskulController');
    Route::resource('student','StudentController');
    Route::resource('banner','BannerController');
    Route::resource('categorytype','CategoryTypeController');
    Route::resource('publisher','PublisherController');
    Route::resource('author','AuthorController');
    Route::resource('student','StudentController');
    Route::resource('book','BookController');
    Route::resource('book_category','BookCategoryController');

    Route::resource('employee','EmployeeController');
    Route::resource('attitude','AttitudeController');

    Route::resource('absent','AbsentController');
    Route::post('/input_absen','AbsentController@input_absen')->name('input_absen');
    Route::post('/data_absen','AbsentController@data_absen')->name('data_absen');

    Route::resource('schedule','ScheduleController');

    Route::resource('article','ArticleController');
    Route::resource('prestation','PrestationController');
    Route::resource('borrow_type','BorrowTypeController');
    Route::resource('book_borrow','BookBorrowController');
    Route::resource('uks','UksController');
    Route::resource('task', 'TaskController');
    Route::resource('examtype', 'ExamTypeController');
    Route::group(['prefix' => 'user'], function() {
        Route::view('/', 'pages.user.index');
    });
    Route::group(['prefix'=>'book_borrow'],function() {
        Route::get('next/{nis}','BookBorrowController@next')->name('book_borrow.next');
        Route::get('delete/{id}','BookBorrowController@destroy')->name('book_borrow.deletes');
    });
    Route::resource('attitude','AttitudeController');
});


Route::prefix('student')->middleware('student')->group(function(){
    Route::get('logout','StudentAuth\LoginController@logout')->name('student.logout');
    Route::middleware('student')->group(function(){
        Route::get('/','StudentController@dashboard')->name('student.dashboard');
        Route::resource('notes','NotesController');
        Route::get('attention','AttentionController@student_attention')->name('student.attention');
        Route::get('task','TaskController@student_task')->name('student.task');
        Route::get('absent','AbsentController@student_index')->name('student.absent');
        Route::post('absent/filter','AbsentController@student_filter')->name(
            'student.absent.filter');
    });
});

Route::prefix('teacher')->middleware('teacher')->group(function(){
    Route::view('/','pages.teacher.dashboard');
    // SUBJECT BAB
    Route::resource('subjectbab','SubjectBabController');
    Route::get('storebab','SubjectBabController@storeBab')->name('teacher.storebab');
    Route::post('insertbab','SubjectBabController@insertbab')->name('teacher.insertbab');

    // QUESTION BANK
    Route::resource('qbank','QuestionBankController');

    Route::resource('document','DocumentController');

    Route::resource('attitudeTransaction','attitudeTransactionController');

    Route::get('setting','QuestionBankController@addSetting')->name('teacher.setting');
    Route::post('addquestion','QuestionBankController@addQuestion')->name('teacher.addquestion');

    // EXAM MANAGE
    Route::resource('exam_manage','ExamManageController');
    Route::get('choose_question/{id}/{subject_id}','ExamManageController@choose_question')->name('teacher.choose_question');

    // Task
    Route::resource('task', 'TaskController');

    // Score
    Route::resource('score', 'ScoreController');
});



Auth::routes();
//Credentials
Route::get('student/login','StudentAuth\LoginController@showLoginForm')->name('student.login.form');
Route::get('teacher/login','TeacherAuth\LoginController@showLoginForm')->name('teacher.login.form');
Route::post('student/login','StudentAuth\LoginController@login')->name('student.login.store');
Route::post('teacher/login','TeacherAuth\LoginController@login')->name('teacher.login.store');
Route::post('teacher/logout','TeacherAuth\LoginController@logout')->name('teacher.logout');
Route::post('student/logout','StudentAuth\LoginController@logout')->name('student.logout');
Route::get('/home', 'HomeController@index')->name('home');

app/Book.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Book extends Model
{
    protected $fillable = [
        'title',
        'description',
        'author_id',
        'publisher_id',
        'publication_year',
        'pages',
        'book_category_id',
        'cover_book'
    ];

    public function book_copy()
    {
        return $this->hasMany('App\BookSingle','book_id','id');
    }

    public function book_was_borrowed()
    {
        return $this->hasMany('App\BookSingle','book_id','id')->where('status','available');
    }

    public function author()
    {
        return $this->hasOne('App\Author','id','author_id');
    }
    public function bookCategory()
    {
        return $this->hasOne('App\BookCategory','id','book_category_id');
    }

    public function publisher()
    {
        return $this->hasOne('App\Publisher','id','publisher_id');
    }
}

app/Http/Controllers/API/BookController.php
<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Book;
use App\BookSingle;
use App\TemporaryBorrow;

class BookController extends Controller
{
    public function book_status()
    {
        return response()->json([
            'book'=>Book::latest()->get(),
        ],200);
    }

    public function data($id)
    {
        return response()->json([
            'book_single'=>BookSingle::where('book_id',$id)->where('status','available')->get(),
        ],200);
    }

    public function load_current_temporary($id)
    {
        $data_array  = [];
        $data_real   = [];
        $array       = [];
        $data = TemporaryBorrow::where('student_id',$id)->latest()->get();
        foreach($data as $value)
        {
            $data_real  = $value;
            $data_array = $value->book->book;
            $array[] = [
                'book_data'=>$data_array,
                'data'     =>$data_real,
            ];
        }
        
        return response()->json(
            $array
        ,200);
    }

    public function show()
    {
        return response()->json([
            'book'=>Book::latest()->get(),
        ],200);
    }
}

app/Http/Controllers/BookController.php
<?php

namespace App\Http\Controllers;

use App\Book;
use App\Author;
use App\Publisher;
use App\BookCategory;
use App\BookSingle;
use Storage;
use DNS1D;
use DNS2D;
use Illuminate\Http\Request;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('pages.book.index',[
            'data'=>Book::latest()->get(),
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.book.create',[
            'authors'        =>Author::latest()->get(),
            'publishers'     =>Publisher::latest()->get(), 
            'book_categories'=>BookCategory::latest()->get()
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request,[
            'title'=>'required',
            'description'=>'required',
            'author_id'=>'required',
            'publisher_id'=>'required',
            'publication_year'=>'required',
            'pages'=>'required',
            'book_category_id'=>'required',
            'cover_book'=>'file'
        ]);

        if($request->hasFile('cover_book'))
        {
            $book = new Book($request->except('copy_count'));
            $book->cover_book = $request->file('cover_book')->store('cover_book');
            $book->save();
            $id = $book->id;
        }else{
            $id = Book::create($request->except('cover_book','copy_count'))->id;           
        }

        for($i = 1;$i<= $request->copy_count;$i++)
        {
            $book_id = BookSingle::create([
                'book_id'=>$id,
                'status' =>'available',
                'date_in'=>date("Y-m-d"),
            ])->id;

            BookSingle::find($book_id)->update([
                'qrcode'=>$book_id,
                'barcode'=>$book_id
            ]);

            Storage::disk('local_bar')
            ->put($book_id.'.jpg',
            base64_decode(DNS1D::getBarcodePNG($book_id, "C39+")));
            Storage::disk('local_qr')
            ->put($book_id.'.jpg',
            base64_decode(DNS2D::getBarcodePNG($book_id, "QRCODE",10,10)));
        } 

        return redirect()->route('book.index')->with('message','Menambahkan');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        return view('pages.book.show',[
            'data'=>$book,
            'book_copy'=>BookSingle::where('book_id',$book->id)->paginate(4),
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Book $book)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        //
    }
}

resources/views/pages/book/create.blade.php
@extends('templates.temp')

@section('title','Buat  Buku')
@section('page_name','Buat  Buku')
@section('breadcrumb')
<a href="" class="kt-subheader__breadcrumbs-link">
    Data Master </a>
<span class="kt-subheader__breadcrumbs-separator"></span>
<a href="{{ route('book.index') }}" class="kt-subheader__breadcrumbs-link">
     Buku </a>
<a href="" class="kt-subheader__breadcrumbs-link">
    Buat  Buku </a>
@endsection

@section('content')
<div class="kt-portlet kt-portlet--mobile">
    <div class="kt-portlet__head kt-portlet__head--lg">
        <div class="kt-portlet__head-label">
            <h3 class="kt-portlet__head-title"> Buku</h3>
        </div>
        <div class="kt-portlet__head-toolbar">
            <div class="kt-portlet__head-wrapper">
                <a href="{{ route('book.index') }}" class="btn btn-clean btn-bold btn-upper btn-font-sm">
                    <i class="la la-long-arrow-left"></i>
                    Kembali
                </a>
            </div>
        </div>
    </div>

    <form class="kt-form kt-form--label-right" method="POST" action="{{ route('book.store') }}"
        enctype="multipart/form-data">
        @csrf
        <div class="kt-portlet__body">
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Nama Buku</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <input type="text" class="form-control" required name="title" value="{{ old('title') }}">
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Deskripsi</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <textarea id="" class="form-control" rows="10" name="description">{{ old('description') }}</textarea>
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Penulis</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <select name="author_id" class="form-control kt_selectpicker" data-live-search="true">
                        @foreach($authors as $author)
                        <option value="{{ $author->id }}">{{ $author->name }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Penerbit</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <select name="publisher_id" class="form-control kt_selectpicker" data-live-search="true">
                        @foreach($publishers as $publisher)
                        <option value="{{ $publisher->id }}">{{ $publisher->name }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Tahun Terbit</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <input type="text" class="form-control" onkeypress="return isNumber(event)" required name="publication_year" value="{{ old('title') }}">
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Halaman</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <input type="text" class="form-control" onkeypress="return isNumber(event)" required name="pages" value="{{ old('title') }}">
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Kategori</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <select name="book_category_id" class="form-control kt_selectpicker" data-live-search="true">
                        @foreach($book_categories as $category)
                        <option value="{{ $category->id }}">{{ $category->name }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Cover Buku</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <input type="file" name="cover_book" id="cover_book" data-allowed-file-extensions="png jpg jpeg" class="dropify" data-height="250">
                </div>
            </div>
            <div class="form-group row">
                <label class="col-form-label col-lg-4 col-sm-12">Jumlah</label>
                <div class="col-lg-4 col-md-9 col-sm-12">
                    <input type="text" class="form-control" onkeypress="return isNumber(event)" required name="copy_count" value="{{ old('title') }}">
                </div>
            </div>

        </div>
        <div class="kt-portlet__foot">
            <div class="kt-form__actions">
                <div class="row">
                    <div class="col-lg-4 col-sm-12"></div>
                    <div class="col-lg-8 col-sm-12">
                        <button type="submit" class="btn btn-brand">Simpan</button>
                        <button type="reset" class="btn btn-secondary">Batal</button>
                    </div>
                </div>
            </div>
        </div>
    </form>
</div>
@endsection

resources/views/pages/book/index.blade.php
@extends('templates.temp')

@section('title','Buku')
@section('breadcrumb')
<a href="" class="kt-subheader__breadcrumbs-link">
    Data Master </a>
<span class="kt-subheader__breadcrumbs-separator"></span>
<a href="{{ route('book.index') }}" class="kt-subheader__breadcrumbs-link">
    Buku </a>
@endsection

@section('content')
<div class="kt-portlet kt-portlet--mobile">
    <div class="kt-portlet__head kt-portlet__head--lg">
        <div class="kt-portlet__head-label">
            <h3 class="kt-portlet__head-title">Buku</h3>
        </div>
        <div class="kt-portlet__head-toolbar">
            <div class="kt-portlet__head-wrapper">
                <a href="{{ route('book.create') }}" class="btn btn-default btn-bold btn-upper btn-font-sm">
                    <i class="flaticon2-add-1"></i>
                    Buat Baru
                </a>
            </div>
        </div>
    </div>

    <div class="kt-portlet__body">
        <!--begin: Datatable -->
        <table class="table data-table">
            <thead>
                <tr>
                    <th>No</th>
                    <th>Nama</th>
                    <th>Jumlah Halaman</th>
                    <th>Kategori</th>
                    <th>Aksi</th>
                </tr>
            </thead>
            <tbody>
                @foreach($data as $field)
                <tr>
                    <td>{{ $loop->index + 1 }}</td>
                    <td>{{ $field->title }}</td>
                    <td>{{ $field->pages }}</td>
                    <td>{{ $field->BookCategory->name }}</td>
                    <td class="text-center">
                        <a href="{{ route('book.destroy',$field) }}"
                            class="btn btn-secondary btn-elevate btn-circle btn-icon delete-btn"> <i
                                class="la la-trash"></i> </a>
                        <a href="{{ route('book.edit',$field) }}"
                            class="btn btn-secondary btn-elevate btn-circle btn-icon"> <i class="la la-edit"></i>
                        </a>
                        <a href="{{ route('book.show',$field) }}"
                            class="btn btn-secondary btn-elevate btn-circle btn-icon"> <i class="la la-eye"></i>
                        </a>
                    </td>
                </tr>
                @endforeach
                
            </tbody>
        </table>
        <!--end: Datatable -->
    </div>
</div>
@endsection

resources/views/pages/book/show.blade.php
@extends('templates.temp')

@section('title','Detail Buku')
@section('breadcrumb')
<a href="" class="kt-subheader__breadcrumbs-link">
    Data Master </a>
<span class="kt-subheader__breadcrumbs-separator"></span>
<a href="{{ route('book.index') }}" class="kt-subheader__breadcrumbs-link">
    Detail Buku </a>
@endsection

@section('content')
<div class="kt-portlet kt-portlet--mobile">
    <div class="kt-portlet__head kt-portlet__head--lg">
        <div class="kt-portlet__head-label">
            <h3 class="kt-portlet__head-title">Detail Buku</h3>
        </div>
        <div class="kt-portlet__head-toolbar">
            <div class="kt-portlet__head-wrapper">
                <a href="{{ route('book.index') }}" class="btn btn-default btn-bold btn-upper btn-font-sm">
                    <i class="fas fa-arrow-left"></i>
                    Kembali
                </a>
            </div>
        </div>
    </div>

    <div class="kt-portlet__body">
        <div class="row">
            <div class="col-md-12">
                <div class="form-group">
                    <h4>Judul</h4>
                    <p>{{ $data->title }}</p>
                </div>
                <hr>
                <div class="form-group">
                    <h4>Deskripsi</h4>
                    <p>{!! $data->description !!}</p>
                </div>
                <hr>
                <div class="form-group">
                    <h4>Penerbit</h4>
                    <p>{{ $data->publisher->name }}</p>
                </div>
                <hr>
                <div class="form-group">
                    <h4>Pengarang</h4>
                    <p>{{ $data->author->name }}</p>
                </div>
                <hr>
                <div class="form-group">
                    <h4>Jumlah Halaman</h4>
                    <p>{{ $data->pages }}</p>
                </div>
                <hr>
                <div class="form-group">
                    <h4>Photo</h4>
                    <input type="file" disabled class="dropify"
                        data-default-file="{{ asset('app/'.$data->cover_book) }}">
                </div>
                <hr>
            </div>
        </div>
    </div>

    <div class="kt-portlet__body">
        <div class="row">
            <div class="col-md-12">
                <h2>QRCode Copy Buku</h2>
                <hr>
            </div>
        </div>
        <div class="row">
            @foreach($book_copy as $field)
            <div class="col-md-3">
                <img src="{{ asset('app/qrcode/'.$field->qrcode.'.jpg') }}" alt="" style="width:100%">                    
                <br><br>
                <div class="alert alert-success">
                    <p>Nomor Buku : {{ $field->id }}</p>
                    <p>Status     : {{ $field->status }}</p>
                </div>
                <br><br>
            </div>
            @endforeach
        </div>
        <div class="row">
            {{ $book_copy->links() }}
        </div>
    </div>
</div>




<!-- 

<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <h5>Buku</h5><a href="{{ route('book.index') }}" class="btn btn-dark"><i class="fa fa-arrow-left"></i> Kembali</a>
            </div>
            <div class="card-body">
                <div class="row">
                    <div class="col-md-12">
                        <div class="form-group">
                            <h4>Judul</h4>
                            <p>{{ $data->title }}</p>
                        </div>
                        <hr>
                        <div class="form-group">
                            <h4>Deskripsi</h4>
                            <p>{!! $data->description !!}</p>
                        </div>
                        <hr>
                        <div class="form-group">
                            <h4>Penerbit</h4>
                            <p>{{ $data->publisher->name }}</p>
                        </div>
                        <hr>
                        <div class="form-group">
                            <h4>Pengarang</h4>
                            <p>{{ $data->author->name }}</p>
                        </div>
                        <hr>
                        <div class="form-group">
                            <h4>Jumlah Halaman</h4>
                            <p>{{ $data->pages }}</p>
                        </div>
                        <hr>
                        <div class="form-group">
                            <h4>Photo</h4>
                            <input type="file" disabled class="dropify"
                                data-default-file="{{ asset('app/'.$data->cover_book) }}">
                        </div>
                        <hr>
                    </div>
                </div>
            </div>
        </div>

        <div class="card">
            <div class="card-body">
            <div class="row">
                <div class="col-md-12">
                    <h2>QRCode Copy Buku</h2>
                    <hr>
                </div>
            </div>
            <div class="row">
                @foreach($book_copy as $field)
                <div class="col-md-3">
                    <img src="{{ asset('app/qrcode/'.$field->qrcode.'.jpg') }}" alt="" style="width:100%">                    
                    <br><br>
                    <div class="alert alert-success">
                        <p>Nomor Buku : {{ $field->id }}</p>
                        <p>Status     : {{ $field->status }}</p>
                    </div>
                    <br><br>
                </div>
                @endforeach
            </div>
            <div class="row">
                {{ $book_copy->links() }}
            </div>
            </div>
        </div>
    </div>
</div>
@endsection -->